// ConfDlg.cpp : implementation file
//

#include "stdafx.h"
#include "numpad.h"
#include "ConfDlg.h"
#include "ComDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfDlg dialog


CConfDlg::CConfDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_com[NP_8] = "n";
	m_com[NP_4] = "o";
	m_com[NP_5] = "s";
	m_com[NP_6] = "e";
}

void CConfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfDlg, CDialog)
	//{{AFX_MSG_MAP(CConfDlg)
	ON_WM_DESTROY()
	ON_CONTROL_RANGE(BN_CLICKED, IDC_CMD0, IDC_CMDSLASH, OnCmdClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfDlg message handlers
void CConfDlg::OnCmdClicked(UINT nID)
{
	int comid;

	comid = nID - IDC_CMD0;
	CComDlg dlg(this);
	dlg.SetCommand(&m_com[comid]);
	int rtn = dlg.DoModal();
	if (rtn == IDOK)
	{
		CButton* pcmd = (CButton*)GetDlgItem(nID);
		if (m_com[comid] == "")
			pcmd->SetWindowText("(nessuno)");
		else
			pcmd->SetWindowText(m_com[comid]);
	}
}

BOOL CConfDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CButton* pbtn;
	pbtn = (CButton*)GetDlgItem(IDC_CHKASSO);
	pbtn->SetCheck(m_ini->GetBoolConf("ShowAssociations"));

	for (int i = 0; i < (NP_SLASH + 1); i++)
	{
		pbtn = (CButton*)GetDlgItem(i + IDC_CMD0);
		if (!(pbtn == NULL))
		{
			if (m_com[i] == "")
				pbtn->SetWindowText("(nessuno)");
			else
				pbtn->SetWindowText(m_com[i]);
		}
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfDlg::SetProfilePath(CString sPath)
{
	sPath += "numpad.ini";
	m_ini = new CIni(sPath);
	LoadConfig();

}

void CConfDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	delete m_ini;	
}

void CConfDlg::LoadConfig()
{
	for (int i = 0; i < (NP_SLASH + 1); i++)
	{
		CString sConf;
		sConf.Format("numpad%i", i);
		m_com[i] = m_ini->GetConf(sConf, m_com[i]);
	}
}

void CConfDlg::SaveConfig()
{
	CButton* pbtn;
	pbtn = (CButton*)GetDlgItem(IDC_CHKASSO);
	//pbtn->SetCheck(m_ini->GetBoolConf("ShowAssociations"));
	m_ini->SetBoolConf("ShowAssociations", (BOOL)pbtn->GetCheck());
	for (int i = 0; i < (NP_SLASH + 1); i++)
	{
		CString sConf;
		sConf.Format("numpad%i", i);
		//m_com[i] = m_ini->GetConf(sConf, m_com[i]);
		m_ini->SetConf(sConf, m_com[i]);
	}
}

void CConfDlg::OnOK()
{
	SaveConfig();
	if (!(AfxGetApp()->m_pMainWnd == NULL))
	{
		//plugin is LOADED
		CNumWnd* pwnd = (CNumWnd*)AfxGetApp()->m_pMainWnd;
		pwnd->LoadConfig();
	}

	CDialog::OnOK();
}
