// Ini.cpp: implementation of the CIni class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "numpad.h"
#include "Ini.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CIni::CIni(CString sFile)
{
	m_sFile = sFile;
}

CIni::~CIni()
{

}

CString CIni::GetConf(CString sKey, CString sDefault)
{
	return ReadConf(&sKey, &sDefault);
}

BOOL CIni::GetBoolConf(CString sKey, BOOL bDefault)
{
	CString sDefault;
	sDefault.Format("%i", bDefault);
	CString sRet = ReadConf(&sKey, &sDefault);
	return _ttoi(sRet);
}

void CIni::SetConf(CString sKey, CString sValue)
{
	WriteConf(&sKey, &sValue);
}

void CIni::SetBoolConf(CString sKey, BOOL bValue)
{
	CString sValue;
	sValue.Format("%i", bValue);
	WriteConf(&sKey, &sValue);
}

CString CIni::ReadConf(CString* sKey, CString* sDefault)
{
	TCHAR tBuff[128];

	GetPrivateProfileString(
		"settings",
		*sKey,
		*sDefault,
		tBuff,
		128,
		m_sFile);

	CString sBuff = tBuff;
	return sBuff;
}

void CIni::WriteConf(CString* sKey, CString* sValue)
{
	WritePrivateProfileString(
		"settings",
		*sKey,
		*sValue,
		m_sFile);
}
