// NumWnd.cpp : implementation file
//

#include "stdafx.h"
#include "numpad.h"
#include "NumWnd.h"
#include "Gos.h"
#include "WinAble.h"
#include "Ini.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNumWnd

HHOOK CNumWnd::m_hHook = 0;

CNumWnd* CNumWnd::m_me = NULL;


CNumWnd::CNumWnd()
{
	m_CreateWin();
}

CNumWnd::CNumWnd(int port, HWND hOwner)
{
	m_hBaseWnd = hOwner;
	m_port = port;
	m_me = this;
	m_CreateWin(hOwner);
}

void CNumWnd::m_CreateWin(HWND hOwner)
{
	CString sClass = ::AfxRegisterWndClass(
		0,
		AfxGetApp()->LoadStandardCursor(IDC_ARROW),
		(HBRUSH)(COLOR_3DFACE +1),
		AfxGetApp()->LoadIcon(IDI_GOSICON)
		);

	CreateEx(0, sClass, _T("Gos Plug-In"), WS_OVERLAPPEDWINDOW,
		0, 731, 1280, 265, hOwner, NULL);

	m_com[NP_8] = "n";
	m_com[NP_4] = "o";
	m_com[NP_5] = "s";
	m_com[NP_6] = "e";
}

CNumWnd::~CNumWnd()
{
	m_me = NULL;
}


BEGIN_MESSAGE_MAP(CNumWnd, CWnd)
	//{{AFX_MSG_MAP(CNumWnd)
	ON_WM_CREATE()
	ON_MESSAGE(GS_CLOSE, OnGosClose)
	ON_MESSAGE(GS_GO, OnGosGo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CNumWnd message handlers

void CNumWnd::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	UnhookWindowsHookEx(m_hHook);

	delete m_gos;
	delete this;
	
	CWnd::PostNcDestroy();
}

int CNumWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	m_gos = new CGosCommand(m_hWnd);
	m_gos->Create();
	m_gos->gosConnect(m_port);

	return 0;
}

LRESULT CNumWnd::OnGosGo(WPARAM wParam, LPARAM lParam)
{	
	LoadConfig();

	m_gos->gosSendOutput("NumPad plug-in 1.0");
	m_gos->gosSendOutput("Sviluppato da Seph (gosclient@yahoo.it)");

	CIni ini(m_gos->gosProfPath() + "numpad.ini");
	if (ini.GetBoolConf("ShowAssociations") == TRUE)
	{
		m_gos->gosSendOutput("Associazioni:");
		m_gos->gosSendOutput("0 = " +		m_com[NP_0]);
		m_gos->gosSendOutput("1 = " +		m_com[NP_1]);
		m_gos->gosSendOutput("2 = " +		m_com[NP_2]);
		m_gos->gosSendOutput("3 = " +		m_com[NP_3]);
		m_gos->gosSendOutput("4 = " +		m_com[NP_4]);
		m_gos->gosSendOutput("5 = " +		m_com[NP_5]);
		m_gos->gosSendOutput("6 = " +		m_com[NP_6]);
		m_gos->gosSendOutput("7 = " +		m_com[NP_7]);
		m_gos->gosSendOutput("8 = " +		m_com[NP_8]);
		m_gos->gosSendOutput("9 = " +		m_com[NP_9]);
		m_gos->gosSendOutput("barra = " +	m_com[NP_SLASH]);
		m_gos->gosSendOutput("asterisco = "+ m_com[NP_AST]);
		m_gos->gosSendOutput("meno = " +		m_com[NP_MINUS]);
		m_gos->gosSendOutput("pi = " +		m_com[NP_PLUS]);
		m_gos->gosSendOutput("punto = " +	m_com[NP_POINT]);
	}

	SetNumLock();
	m_hHook = SetWindowsHookEx(WH_KEYBOARD, HookProc,
		AfxGetApp()->m_hInstance, AfxGetApp()->m_nThreadID);
	//ShowWindow(SW_SHOW);
	return 0;
}

LRESULT CNumWnd::OnGosClose(WPARAM wParam, LPARAM lParam)
{
	m_gos->gosClose();
	DestroyWindow();
	return 0;
}

void CNumWnd::SetNumLock()
{
	BYTE keyState[256];

	GetKeyboardState((LPBYTE)&keyState);
	/*if( (bState && !(keyState[VK_NUMLOCK] & 1)) ||
		(!bState && (keyState[VK_NUMLOCK] & 1)) )*/
	if (!(keyState[VK_NUMLOCK] & 1))
	{
		INPUT in[2];
		::ZeroMemory(in, sizeof(in));
		
		in[0].type = in[1].type = INPUT_KEYBOARD;
		in[0].ki.wVk = in[1].ki.wVk = VK_NUMLOCK;
		in[0].ki.dwFlags = KEYEVENTF_EXTENDEDKEY;
		in[1].ki.dwFlags = KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP;

		SendInput(2, in, sizeof(INPUT));
	}
}
//keyboard hook procedure
LRESULT CALLBACK CNumWnd::HookProc(int code, WPARAM wParam, LPARAM lParam)
{

	if (code < 0)
		return CallNextHookEx(m_hHook, code, wParam, lParam);

	if ((lParam & 0xC0000000) == 0) SetNumLock();

	if ( ( (wParam >= NP_BASE) && (wParam <= NP_BASE + NP_SLASH) ) &&
		( ::GetForegroundWindow() == m_me->m_hBaseWnd ) )
	{
		if ((lParam & 0xC0000000) == 0)
		{		
			int npcode = wParam - NP_BASE;
			if (!(m_me->m_com[npcode] == ""))
				m_me->m_gos->gosSendInput(m_me->m_com[npcode]);
		}
		
		return 1; //per bloccare il messaggio
	}

	return CallNextHookEx(m_hHook, code, wParam, lParam);
}

void CNumWnd::LoadConfig()
{
	CIni ini(m_gos->gosProfPath() + "numpad.ini");

	for (int i = 0; i < (NP_SLASH + 1); i++)
	{
		CString sConf;
		sConf.Format("numpad%i", i);
		m_com[i] = ini.GetConf(sConf, m_com[i]);
	}
}